escript::AbstractTransportProblem Class Reference

Give a short description of what AbstractTransportProblem does. More...

`#include <AbstractTransportProblem.h>`

Inheritance diagram for escript::AbstractTransportProblem:

## Public Member Functions

| AbstractTransportProblem ()
| Default constructor for AbstractTransportProblem. More...
| AbstractTransportProblem (const int blocksize, const FunctionSpace &functionspace)
virtual | ~AbstractTransportProblem ()
| Destructor. More...
int | isEmpty () const
FunctionSpace | getFunctionSpace () const
| returns the column function space More...
int | getBlockSize () const
| returns the block size More...
Data | solve (Data &u0, Data &source, const double dt, boost::python::object &options)
| returns the solution u for a time step dt>0 with initial value u0 at time t=0 More...
virtual void | resetTransport (bool preserveSolverData) const
| resets the transport operator typically as they have been updated. More...
void | insertConstraint (Data &source, Data &q, Data &r)
| inserts constraint u_{,t}=r where q>0 into the problem More...
virtual double | getSafeTimeStepSize () const
virtual double | getUnlimitedTimeStepSize () const

## Private Member Functions

virtual void | setToSolution (Data &out, Data &u0, Data &source, double dt, boost::python::object &options)
| sets solution out by time step dt. More...
virtual void | copyConstraint (Data &source, Data &q, Data &r)
| copy constraint u_{,t}=r where q>0 into the problem it can be assumed that q and r are not empty and have appropriate shape and function space. More...

## Private Attributes

int | m_empty
int | m_blocksize
FunctionSpace | m_functionspace

## Detailed Description

Give a short description of what AbstractTransportProblem does.

Description: Give a detailed description of AbstractTransportProblem

Template Parameters: For templates describe any conditions that the parameters used in the template must satisfy

## Constructor & Destructor Documentation

## AbstractTransportProblem() [1/2]

escript::AbstractTransportProblem::AbstractTransportProblem | ( |  | ) |

Default constructor for AbstractTransportProblem.

Description: Default constructor for AbstractTransportProblem

Preconditions: Describe any preconditions

Throws: Describe any exceptions thrown

References m_empty.

## AbstractTransportProblem() [2/2]

escript::AbstractTransportProblem::AbstractTransportProblem | ( | const int | blocksize,
|  | const FunctionSpace & | functionspace
| ) |  |

References ESYS_ASSERT.

## ~AbstractTransportProblem()

escript::AbstractTransportProblem::~AbstractTransportProblem | ( |  | ) |

virtual

Destructor.

## Member Function Documentation

## copyConstraint()

void escript::AbstractTransportProblem::copyConstraint | ( | Data & | source,
|  | Data & | q,
|  | Data & | r
| ) |  |

private virtual

copy constraint u_{,t}=r where q>0 into the problem it can be assumed that q and r are not empty and have appropriate shape and function space.

Reimplemented in paso::TransportProblem.

Referenced by insertConstraint().

## getBlockSize()

int escript::AbstractTransportProblem::getBlockSize | ( |  | ) | const

inline

returns the block size

References isEmpty(), and m_blocksize.

Referenced by insertConstraint(), and solve().

## getFunctionSpace()

FunctionSpace escript::AbstractTransportProblem::getFunctionSpace | ( |  | ) | const

inline

returns the column function space

References isEmpty(), and m_functionspace.

Referenced by paso::TransportProblem::copyConstraint(), insertConstraint(), paso::TransportProblem::setToSolution(), and solve().

## getSafeTimeStepSize()

double escript::AbstractTransportProblem::getSafeTimeStepSize | ( |  | ) | const

virtual

Reimplemented in paso::TransportProblem.

Referenced by BOOST_PYTHON_MODULE().

## getUnlimitedTimeStepSize()

double escript::AbstractTransportProblem::getUnlimitedTimeStepSize | ( |  | ) | const

virtual

Reimplemented in paso::TransportProblem.

Referenced by BOOST_PYTHON_MODULE().

## insertConstraint()

void escript::AbstractTransportProblem::insertConstraint | ( | Data & | source,
|  | Data & | q,
|  | Data & | r
| ) |  |

inserts constraint u_{,t}=r where q>0 into the problem

References copyConstraint(), escript::Data::expand(), getBlockSize(), escript::Data::getDataPointRank(), escript::Data::getDataPointShape(), escript::Data::getDataPointSize(), getFunctionSpace(), isEmpty(), and escript::Data::isEmpty().

Referenced by BOOST_PYTHON_MODULE().

## isEmpty()

int escript::AbstractTransportProblem::isEmpty | ( |  | ) | const

References m_empty.

Referenced by BOOST_PYTHON_MODULE(), getBlockSize(), getFunctionSpace(), insertConstraint(), and solve().

## resetTransport()

void escript::AbstractTransportProblem::resetTransport | ( | bool | preserveSolverData | ) | const

virtual

resets the transport operator typically as they have been updated.

Reimplemented in paso::TransportProblem.

Referenced by BOOST_PYTHON_MODULE().

## setToSolution()

void escript::AbstractTransportProblem::setToSolution | ( | Data & | out,
|  | Data & | u0,
|  | Data & | source,
|  | double | dt,
|  | boost::python::object & | options
| ) |  |

private virtual

sets solution out by time step dt.

Reimplemented in paso::TransportProblem.

Referenced by solve().

## solve()

Data escript::AbstractTransportProblem::solve | ( | Data & | u0,
|  | Data & | source,
|  | const double | dt,
|  | boost::python::object & | options
| ) |  |

returns the solution u for a time step dt>0 with initial value u0 at time t=0

References getBlockSize(), escript::Data::getDataPointSize(), getFunctionSpace(), escript::Data::getFunctionSpace(), isEmpty(), and setToSolution().

Referenced by BOOST_PYTHON_MODULE().

## Member Data Documentation

## m_blocksize

int escript::AbstractTransportProblem::m_blocksize

private

Referenced by getBlockSize().

## m_empty

int escript::AbstractTransportProblem::m_empty

private

Referenced by AbstractTransportProblem(), and isEmpty().

## m_functionspace

FunctionSpace escript::AbstractTransportProblem::m_functionspace

private

Referenced by getFunctionSpace().

The documentation for this class was generated from the following files:

- AbstractTransportProblem.h
- AbstractTransportProblem.cpp